#pragma config(I2C_Usage, I2C1, i2cSensors)
#pragma config(Sensor, in1,    line,           sensorReflection)
#pragma config(Sensor, I2C_1,  wormEnc,        sensorQuadEncoderOnI2CPort,    , AutoAssign )
#pragma config(Motor,  port1,           claw,          tmotorVex393_HBridge, openLoop)
#pragma config(Motor,  port2,           rightBack,     tmotorVex393TurboSpeed_MC29, openLoop, driveRight)
#pragma config(Motor,  port3,           leftBack,      tmotorVex393TurboSpeed_MC29, openLoop, driveLeft)
#pragma config(Motor,  port4,           crank4,        tmotorVex393TurboSpeed_MC29, openLoop)
#pragma config(Motor,  port5,           crank5,        tmotorVex393TurboSpeed_MC29, openLoop)
#pragma config(Motor,  port6,           crank6,        tmotorVex393TurboSpeed_MC29, openLoop)
#pragma config(Motor,  port7,           crank7,        tmotorVex393TurboSpeed_MC29, openLoop)
#pragma config(Motor,  port8,           leftFront,     tmotorVex393TurboSpeed_MC29, openLoop, driveLeft)
#pragma config(Motor,  port9,           rightFront,    tmotorVex393TurboSpeed_MC29, openLoop, driveRight)
#pragma config(Motor,  port10,          worm,          tmotorVex393_HBridge, openLoop, encoderPort, I2C_1)
//*!!Code automatically generated by 'ROBOTC' configuration wizard               !!*//

// This file is part of Vex-920-2016, and is therefore licensed under the GNU GPLv3 public license.

/* Controls
	Ch3: 		Movement: Forwards and backwards
	Ch4: 		Movement: Rotation
	Btn7U: 	Movement: Switches between driving modes
	Btn8U: 	Claw: 		Open
	Btn9D: 	Claw: 		Close
	Btn6U:	Crank:		Up
	Btn6D:	Crank:		Down
*/

// This code is for the VEX cortex platform
#pragma platform(VEX2)

// Select Download method as "competition"
#pragma competitionControl(Competition)

//Main competition background code...do not modify!
#include "Vex_Competition_Includes.c"

int lcdMode = 0;

// Methods
/*! Moves the bot based on input from the left stick.
*/
void moveArcade() {
	//displayLCDNumber(0, 0, vexRT[Ch3]);

	motor[rightFront] = vexRT[Ch3] - vexRT[Ch4];
	motor[rightBack] = vexRT[Ch3] - vexRT[Ch4];
	motor[leftFront] = -vexRT[Ch3] - vexRT[Ch4];
	motor[leftBack] = -vexRT[Ch3] - vexRT[Ch4];
}

/*! Moves the bot based on input from both sticks.
*/
void moveTank() {
	motor[rightFront] = vexRT[Ch2];
	motor[rightBack] = vexRT[Ch2];
	motor[leftFront] = -vexRT[Ch3];
	motor[leftBack] = -vexRT[Ch3];
}

/*! Opens or closes the claw.
*/
void checkClaw() {
	if (vexRT[Btn8U] == 1) {
		motor[claw] = -127; // open
	} else if (vexRT[Btn8D] == 1) {
		motor[claw] = 127; // close
	} else {
		motor[claw] = 0;
	}
}
/* lcd is 16 char long */
string fireTop = 		" /\\ N\\  /\\ N\\   ";
string fireBottom =	"/  V  \\/  V  \\__";
int index = 0;
void fireAnim(int t) {
		//if (t % 3000 >= 100) return;
		if (index >= 16) index = 0;
		setLCDPosition(0, index);
		displayNextLCDChar(stringGetChar(fireTop, index));
		//setLCDPosition(1, index);
		//displayNextLCDNumber(index);
		//displayNextLCDChar(stringGetChar(fireBottom, index));
		index++;
}

void openClaw() {
	motor[claw] = -127;
}

void closeClaw() {
	motor[claw] = 50;
}

void clawOff() {
	motor[claw] = 0;
}

void windCrank() {
	if (vexRT[Btn6U] == 1) {
		motor[crank4] = -127;
		motor[crank5] = 127;
		motor[crank6] = 127;
		motor[crank7] = -127;
	} else if (vexRT[Btn6D] == 1) {
		motor[crank4] = 127 / 4;
		motor[crank5] = -(127 / 4);
		motor[crank6] = -(127 / 4);
		motor[crank7] = 127 / 4;
	} else {
		motor[crank4] = 0;
		motor[crank5] = 0;
		motor[crank6] = 0;
		motor[crank7] = 0;
	}
}

void crankDown() {
	motor[crank4] = 127 / 4;
	motor[crank5] = -(127 / 4);
	motor[crank6] = -(127 / 4);
	motor[crank7] = 127 / 4;
}

void crankUp() {
	motor[crank4] = -(127);
	motor[crank5] = 127;
	motor[crank6] = 127;
	motor[crank7] = -(127);
}

void crankOff() {
	motor[crank4] = 0;
	motor[crank5] = 0;
	motor[crank6] = 0;
	motor[crank7] = 0;
}

void extend() {
	//setMotorTarget(worm, 300, 127, 0);
	motor[worm] = -127;
}

void wormOff() {
	motor[worm] = 0;
}

void retract() {
	motor[worm] = 127;
}

void checkWorm() {
	if (vexRT[Btn5D] == 1) {
		retract();
	}else if (vexRT[Btn5U] == 1) {
		extend();
	}else {
		wormOff();
		resetMotorEncoder(worm);
	}
}


void checkLCD() {
	switch ((int) nLCDButtons) {
		case 1:
			lcdMode = 0;
			break;
		case 2:
			lcdMode = 1;
			break;
		case 4:
			lcdMode = 2;
			break;
		default:
			break;
		}
	}


/*---------------------------------------------------------------------------*/
/*													Pre-Autonomous Functions												 */
/*																																					 */
/*	You may want to perform some actions before the competition starts.			 */
/*	Do them in the following function.	You must return from this function	 */
/*	or the autonomous and usercontrol tasks will not be started.	This			 */
/*	function is only called once after the cortex has been powered on and		 */
/*	not every time that the robot is disabled.															 */
/*---------------------------------------------------------------------------*/

void pre_auton()
{
	// Set bStopTasksBetweenModes to false if you want to keep user created tasks
	// running between Autonomous and Driver controlled modes. You will need to
	// manage all user created tasks if set to false.
	bStopTasksBetweenModes = true;
	lcdMode = 1;
	// Set bDisplayCompetitionStatusOnLcd to false if you don't want the LCD
	// used by the competition include file, for example, you might want
	// to display your team name on the LCD in this function.
	bDisplayCompetitionStatusOnLcd = false;

	// All activities that occur before the competition starts
	// Example: clearing encoders, setting servo positions, ...
}

task autonomous()
{
	clearTimer(T1);
	int round = 0;
	bool done = false;
	while (true) {
		bLCDBacklight = true;
		if (lcdMode == 0) {
			fireAnim(T2);
		}else if (lcdMode == 1) {
			displayLCDString(0, 0, "920BlazeIt");
			clearLCDLine(1);
		}else if (lcdMode == 2) {
			displayLCDNumber(1, 0, round);
			clearLCDLine(0);
		}
		//displayLCDNumber(1, 0, SensorValue[line]);
		clearTimer(T1);
		while (round == 0 && time1[T1] <= 60) { // open claw
			openClaw();
			done = false;
		}

		if (!done) {
			done = true;
			round = 1;
			clawOff();
		}

		clearTimer(T1);
		while (round == 1 && time1[T1] <= 800/* && SensorValue[line] >= 8900*/) { // move to line/move for 50 ms
			motor[rightBack] = -(127 / 2);
			motor[rightFront] = -(127 / 2);
			motor[leftBack] = (127 / 2);
			motor[leftFront] = (127 / 2);
			done = false;
		}
		//while (round == 0 && time1[T1] <= 750){
		//	displayLCDNumber(0, 0, time1[T1]);
		//	motor[rightBack] = -127;
		//	motor[rightFront] = -127;
		//	motor[leftBack] = 127;
		//	motor[leftFront] = 127;
		//}
		if (!done) {
			done = true;
			round = 2;
			motor[rightBack] = 0;
			motor[rightFront] = 0;
			motor[leftBack] = 0;
			motor[leftFront] = 0;
		}

		clearTimer(T1);
		while (round == 2 && time1[T1] <= 1500) { // lower crank
			crankDown();
			openClaw();
			done = false;
		}

		if (!done) {
			done = true;
			round = 3;
			crankOff();
			clawOff();
		}

		clearTimer(T1);
		while (round == 3 && time1[T1] <= 500) { // close claw
			closeClaw();
			done = false;
		}

		if (!done) {
			done = true;
			round = 4;
			clawOff();
		}

		clearTimer(T1);
		while (round == 4 && time1[T1] <= 3500) { // winding
			crankUp();
			done = false;
		}

		if (!done) {
			done = true;
			round = 5;
		}

		clearTimer(T1);
		while (round == 5 && time1[T1] <= 2000) { // open claw
			openClaw();
			done = false;
		}

		if (!done) {
			done = true;
			round = 6;
			motor[claw] = 0;
			crankOff();
		}
	}
	//AutonomousCodePlaceholderForTesting();
}

task usercontrol()
{
	bool mode = true; // for switching drive modes
	bool coolDown = false;
	while (true)
	{
		checkLCD();
		bLCDBacklight = true;

		clearTimer(T2);

		//displayLCDNumber(0, 0, motor[crank4]); // crank4 & crank5 are too fast
		//displayLCDString(1, 5, "Line Sensor");
		//displayLCDNumber(1, 0, SensorValue[line]);
		//displayLCDString(0, 0, fireTop);
		if (lcdMode == 0) {
			fireAnim(T2);
		}else if (lcdMode == 1) {
			displayLCDString(1, 0, "920BlazeIt");
		}else if (lcdMode == 2) {
			displayLCDNumber(1, 0, nMotorEncoder[worm], 6);
		}
		if (mode) {
			moveArcade();
		} else {
			moveTank();
		}

		if (!coolDown) {
			time1[T1] = 0;
		}

		if (vexRT[Btn7U] == 1 && time1[T1] == 0) { // btn down and no cooldown
				mode = !mode;
				coolDown = true;
		} else if (time1[T1] >= 5000) { // cooldown over
			time1[T1] = 0;
			coolDown = false;
		}

		checkClaw();
		windCrank();
		checkWorm();
	}
}
